image: lganee/fatapache:1.1.11

stages:
  - build
  - test

variables:
  COMPOSER_ALLOW_SUPERUSER: "1"

.before_script_t ssh-agenemplate: &ssh_key
  before_script:
    - eval $(ssh-agent -s)
    - ssh-add <(echo "$SSH_PRIVATE_KEY_DEPLOY_DEV")
    - mkdir -p ~/.ssh data/ tmp/ logs/
    - '[[ -f /.dockerenv ]] && echo -e "Host *\n\tStrictHostKeyChecking no\n\n" > ~/.ssh/config'

test:
  only:
    - master
  <<: *ssh_key
  script:
    - date +"%T"
    - composer install
    - vendor/phpunit/phpunit/phpunit --colors=never --testdox --coverage-text --coverage-html coverage-output/ --log-junit=logs/junit.xml --coverage-clover=logs/coverage.xml
    - date +"%T"
    - /opt/sonar-scanner/bin/sonar-scanner -Dsonar.login=$SONAR_LOGIN
    - date +"%T"
    - cd $PWD/coverage-output/ && zip -q -r $PWD/coverage.seda2pdf.zip .
    - scp -P $SSH_PORT_DEPLOY_DEV $PWD/coverage.seda2pdf.zip $URL_DEPLOY_DEV:$DEPLOY_DIR
    - ssh -p $SSH_PORT_DEPLOY_DEV $URL_DEPLOY_DEV "sudo rm -rf $DEPLOY_DIR/webroot/coverage/seda2pdf"
    - ssh -p $SSH_PORT_DEPLOY_DEV $URL_DEPLOY_DEV "sudo unzip -q -o $DEPLOY_DIR/coverage.seda2pdf.zip -d $DEPLOY_DIR/webroot/coverage/seda2pdf"
    - ssh -p $SSH_PORT_DEPLOY_DEV $URL_DEPLOY_DEV "sudo rm -fr $DEPLOY_DIR/coverage.seda2pdf.zip"
  coverage: '/^ *Lines: *\d+\.\d+%/'

include:
  - template: Code-Quality.gitlab-ci.yml
  - template: Jobs/SAST.gitlab-ci.yml
  - template: Jobs/Secret-Detection.gitlab-ci.yml
  - template: Security/Dependency-Scanning.gitlab-ci.yml

code_quality:
  services:
  tags:
    - cq-sans-dind
